<template>
  <div v-if="!loading" class="user">
    <div class="username-block">
      {{lead.name}}
      <v-btn icon @click="leftBar.show = !leftBar.show">
        <v-icon>mdi-dots-horizontal</v-icon>
      </v-btn>
    </div>
    <v-divider v-if="leftBar.show"/>
    <div class="left-bar" :class="{'_active':leftBar.show}">
      <div class="user-name mb-3">{{lead.name}}</div>
      <div class="user-added mb-3">Добавлен: <span>{{lead.createdAt && formatDate(lead.createdAt, true) ||'не известно'}}</span></div>
      <div class="status mb-3">
        Статус:
        <v-menu
          bottom
          offset-y
          max-height="300px"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-chip
                x-small
              :style="{
                          backgroundColor: lead.status && lead.status.color || 'gray',
                          color: '#FFF'
                        }"
              v-bind="attrs"
              v-on="on"
            >{{statusLead}}</v-chip>
          </template>
          <v-list>
            <v-list-item
              v-for="(tag, i) in tags"
              :key="tag._id"
              @click="selectStatus(lead, tag, i)"
            >
              <v-list-item-title style="line-height: inherit!important;">
                <v-chip
                    small
                  :style="{
                          backgroundColor: tag.color,
                          color: '#fff'
                        }"
                >{{ tag.name }}</v-chip>
              </v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </div>
      <div class="budget">
        <p style="grid-column: span 1">
          Бюджет: <v-btn v-if="!leftBar.isInputBudget && !lead.budget" @click="leftBar.isInputBudget = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
          <input v-if="leftBar.isInputBudget || lead.budget" v-model="lead.budget" @change="changeValueLeadFields" class="mr-2" type="text">
        </p>
        <p style="grid-column: span 1">
          Долг: <v-btn v-if="!leftBar.isInputDebt && !lead.debt" @click="leftBar.isInputDebt = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
          <input v-if="leftBar.isInputDebt || lead.debt" v-model="lead.debt" @change="changeValueLeadFields" class="mr-2" type="text">
        </p>
        <p style="grid-column: span 2">
          Предоплата: <v-btn v-if="!leftBar.isInputPrepay && !lead.prepay" @click="leftBar.isInputPrepay = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
          <input v-if="leftBar.isInputPrepay || lead.prepay" v-model="lead.prepay" @change="changeValueLeadFields" class="mr-2" type="text">
        </p>
        <p style="grid-column: span 2">
          Пол.решение: <v-btn v-if="!leftBar.isInputTrueAnswer && !lead.answer" @click="leftBar.isInputTrueAnswer = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
          <input v-if="leftBar.isInputTrueAnswer || lead.answer" v-model="lead.answer" @change="changeValueLeadFields" class="mr-2" type="text">
        </p>
        <p style="grid-column: span 2">
          Предложенная сумма: <v-btn v-if="!leftBar.isProposedAmount && !lead.proposed_amount" @click="leftBar.isProposedAmount = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
          <input v-if="leftBar.isProposedAmount || lead.proposed_amount" v-model="lead.proposed_amount" @change="changeValueLeadFields" class="mr-2" type="text">
        </p>
      </div>
      <div class="region mb-3">Регион:
        <v-menu
          bottom
          offset-y
        >
          <template v-slot:activator="{ on, attrs }">
            <v-chip
              small
              :style="{
                          backgroundColor: lead.region && '#01b709' || '#3183FF',
                          color: '#FFF'
                        }"
              v-bind="attrs"
              v-on="on"
            >{{lead.region &&  'Отправлен в "' + lead.region.name +'"' || 'Отправить в регион'}}</v-chip>
          </template>
          <v-list v-if="regions.length">
            <v-list-item
              v-for="(region, i) in regions"
              :key="region._id"
              @click="toRegion(lead._id, region._id, i)"
            >
              <v-list-item-title style="line-height: inherit!important;">
                <v-chip
                  region
                >{{ region.name }}</v-chip>
              </v-list-item-title>
            </v-list-item>
          </v-list>
          <v-list v-else>
            <v-list-item
            >
              <v-list-item-title style="line-height: inherit!important;">
                <v-chip
                  region
                >Регионы отсутствуют</v-chip>
              </v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </div>
      <v-btn @click="deleteLead" color="red" style="color: white" small>Удалить лид</v-btn>
      <div class="user-calendar" style="cursor: pointer" @click="rightBar.calendar = !rightBar.calendar, leftBar.show = !leftBar.show">
        <img src="../assets/img/general/calendar.svg" alt="">
        Календарь
      </div>
      <div class="user-tabs">
        <v-btn
          v-for="tab in leftBar.tabs"
          :key="tab.id + '-key_1'"
          :class="{'_active':leftBar.activeTab === tab.id}"
          class="user-tab"
          :text="!leftBar.activeTab === !tab.id"
          @click="leftBar.activeTab = tab.id"
        >
          {{tab.title}}
          <img style="margin-left: 5px" src="../assets/img/general/menu-select.svg" v-if="tab.id === 5" alt="">
        </v-btn>
      </div>
      <v-expand-transition>
        <div :key="'left-bar-'+111" v-show="leftBar.activeTab === 1">
          <!--      информация о лиде-->
          <div class="tab-data">
            <p style="font-weight: bold">Информация о лиде</p>
            <label class="data-element">
              <p>Имя: </p>
              <v-btn v-if="!leftBar.isInputLeadInfo.leadName && !lead.name" @click="leftBar.isInputLeadInfo.leadName = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
              <input v-if="leftBar.isInputLeadInfo.leadName || lead.name" v-model="lead.name" @change="changeValueLead" class="mr-2" type="text">
            </label>
            <label class="data-element">
              <p>Телефон: </p>
              <div class="d-flex align-center">
                <a v-if="lead.phone" target="_blank" :href="`https://wa.me/${lead.phone}`"><img src="../assets/img/icons/whatsapp.png" alt=""></a>
                <a v-if="lead.phone" target="_blank" :href="`https://viber://chat?number=${lead.phone}`"><img src="../assets/img/icons/viber.png" alt=""></a>
                <p>
                  <v-form v-model="validPhone">
                    <v-btn v-if="!leftBar.isInputLeadInfo.leadPhone && !lead.phone" @click="leftBar.isInputLeadInfo.leadPhone = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
                    <v-text-field v-if="leftBar.isInputLeadInfo.leadPhone || lead.phone" :rules="[phoneNumberRule]" v-model="lead.phone" @change="changeValueLead" class="mr-2" type="text"/>
                  </v-form>
                </p>
              </div>
            </label>
            <label class="data-element">
              <p>Email: </p><p>
              <v-btn v-if="!leftBar.isInputLeadInfo.leadEmail && !lead.email" @click="leftBar.isInputLeadInfo.leadEmail = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
              <input v-if="leftBar.isInputLeadInfo.leadEmail || lead.email" v-model="lead.email" @change="changeValueLead" class="mr-2" type="text">
            </p>
            </label>
            <label class="data-element">
              <p>Город: </p><p>
              <v-btn v-if="!leftBar.isInputLeadInfo.leadCity && !lead.city" @click="leftBar.isInputLeadInfo.leadCity = true" color="grey" x-small rounded class="mr-2 white--text">Указать</v-btn>
              <v-autocomplete
                v-if="leftBar.isInputLeadInfo.leadCity || lead.city"
                v-model="lead.city"
                :loading="loadingCities"
                :items="citiesItems"
                :search-input.sync="search"
                cache-items
                class="mx-4"
                flat
                hide-no-data
                hide-details
                :label="lead.city"
                item-text="city"
                solo-inverted
              >
                <template v-slot:item="data">
                  <v-list-item-content @click.prevent="changeValueLead" v-text="data.item.city"></v-list-item-content>
                </template>
              </v-autocomplete>
            </p>
            </label>
          </div>

          <!--     Доп информация о лиде-->
          <div class="tab-data">
            <label v-for="field in lead.fields" v-show="field.category === 'Контакты'" :key="field._id + '-contacnts'" class="data-element">
              <p>{{field.name}}</p>
              <select @change="changeValueLeadFields" v-if="field.type==='Список'" v-model="field.value">
                <option v-for="val in field.values" :key="val+'select-option'" :value="val">{{val}}</option>
              </select>
              <input v-else-if="field.type==='Текст'" @change="changeValueLeadFields" v-model="field.value" type="text">
              <div v-else-if="field.type==='Цифровое' && field.name.toLowerCase().indexOf('телефон') >= 0" class="d-flex align-center">
                <a target="_blank" :href="`https://wa.me/${field.value}`"><img src="../assets/img/icons/whatsapp.png" alt=""></a>
                <a target="_blank" :href="`https://viber://chat?number=${field.value}`"><img src="../assets/img/icons/viber.png" alt=""></a>
                <input @change="changeValueLeadFields" v-model="field.value" type="number">
              </div>
              <input v-else-if="field.type==='Цифровое'" @change="changeValueLeadFields" v-model="field.value" type="number">
              <textarea v-else-if="field.type==='Текстовая область'" @change="changeValueLeadFields" v-model="field.value" />
              <input v-else-if="field.type==='Чекбокс'" @change="changeValueLeadFields" v-model="field.value" type="checkbox">
            </label>
          </div>
          <div class="tab-data">
            <label v-for="field in lead.fields" v-show="field.category === 'Сделки'" :key="field._id" class="data-element">
              <p>{{field.name}}</p>
              <select v-if="field.type==='Список'" @change="changeValueLeadFields" v-model="field.value">
                <option v-for="(val, i) in field.values" :value="val" :key="`select-option-${i}-${val}`">{{val}}</option>
              </select>
              <input v-else-if="field.type==='Текст'" @change="changeValueLeadFields" v-model="field.value" type="text">
              <input v-else-if="field.type==='Цифровое'" @change="changeValueLeadFields" v-model="field.value" type="number">
              <textarea v-else-if="field.type==='Текстовая область'" @change="changeValueLeadFields" v-model="field.value" />
              <input v-else-if="field.type==='Чекбокс'" @change="changeValueLeadFields" v-model="field.value" type="checkbox">
            </label>
          </div>
        </div>
      </v-expand-transition>

      <v-expand-transition>
        <div :key="'left-bar-'+222" v-show="leftBar.activeTab === 2">
          <div style="width: 100%" v-for="file in lead.messages" :key="file.file">
            <v-list-item v-if="file.file" two-line>
              <v-list-item-content>
                <v-list-item-title>{{file.filename}}</v-list-item-title>
                <v-list-item-subtitle>{{file.date}}</v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-btn text target="_blank" :href="url+file.file">Открыть</v-btn>
              </v-list-item-action>
            </v-list-item>
          </div>
        </div>
      </v-expand-transition>
    </div>
    <div
      style="width: 100%;height: 100%;position: relative;display: block"
      @dragenter.prevent="dragEnter"
      @dragover.prevent="dragOver"
      @drop.prevent="drop($event)"
    >
      <transition-group name="anim-right-bar" style="width: 100%;height: 100%;position: relative;display: block">
        <div :key="1111" v-show="dropFlag" class="drop-window-wrap"
             @dragleave.prevent="dragLeave">
          <div class="drop-window">
            <p>
              Прикрепить файлы<br>
              <span style="font-size: 14px; font-style: italic; opacity: .7">Отпустите кнопку мыши для прикрепления файлов</span>
            </p>
          </div>
        </div>
        <div :key="111" class="right-bar" v-show="!rightBar.calendar">
          <div v-if="1===2" class="bar-container">
            <div class="bar-container-title">
              <p>Исходящее SMS</p><p>23.03.2021 18:19</p>
            </div>
            <div class="bar-container-text">
              Компания «Автоюрист» приветствует Вас. Мы свяжемся с Вами и ответим на все вопросы в ближайшее время.
              Бесплатный номер 8-800-201-32-36
            </div>
          </div>
          <div v-if="lead.note" class="bar-container">
            <div class="bar-container-title">
              <p>Дополнительная информация</p>
              <p>{{formatDate(lead.createdAt, true)}}</p>
            </div>
            <div class="bar-container-text mb-4" v-html="lead.note">
            </div>
          </div>
          <div
            v-for="(message, index) in lead.messages"
            :key="'message-'+index + message.id || Math.random()"
            :class="{task:message.task && message.statusTask}"
            class="bar-container"
          >
            <div class="bar-container-title">
              <p v-if="message.task">
                {{message.from.username}}
                <img src="../assets/img/general/arrow-next.svg" alt="">
                {{message.task && 'Задача'}}
                <img v-if="message.task" src="../assets/img/general/arrow-next.svg" alt="">
                <span>{{message.task}}</span>
              </p>
              <p v-else>{{message.from.username}} <img src="../assets/img/general/arrow-next.svg" alt="">{{message.type}}</p>
              <p>{{formatDate(message.date, true)}}</p>
            </div>
            <div class="bar-container-text mb-4">
              {{message.message}}
            </div>
            <div v-if="message.file" class="bar-container-text">
              <a v-if="message.extension === 'jpg'||message.extension === 'jpeg'" target="_blank" :href="url+message.file">
                <img style="max-width: 100px" :src="url+message.file" alt="">
              </a>
              <a v-else target="_blank" :href="url+message.file" style="cursor: pointer"><span>Файлы:</span> <v-chip small color="grey" style="cursor: pointer; color: white">{{ message.filename }}</v-chip></a>
            </div>
            <v-divider v-if="message.task" class="my-2"/>
            <div class="bar-container-text" v-if="message.task && message.statusTask">
              <div style="font-style: italic; font-size: 12px; opacity: .8">
                <span>Задача:<v-chip x-small color="blue" style="color: white">{{message.task}}</v-chip></span>
                <span v-if="message.taskDate">
                Выполнить до:
                <v-chip x-small color="blue" style="color: white">
                  {{formatDate(message.taskDate) + ' ' + (message.taskHour && message.taskHour || '09:00')}}
                </v-chip>
              </span>
              </div>
              <div v-if="isDev">{{index}} - индекс сообщения</div>
              <div class="ml-auto">
                <v-btn @click="dialogSwapTaskResponsible = message.id" icon title="Сменить отвественного" color="red">
                  <v-icon>mdi-swap-horizontal</v-icon>
                </v-btn>
                <Modal v-if="dialogSwapTaskResponsible === message.id" @close="dialogSwapTaskResponsible = 0" no-border>
                  <template v-slot:body>
                    <v-card class="pa-4">
                      <v-card-title class="text-center">Сменить отвественного задачи</v-card-title>
                      <v-autocomplete
                        v-model="selectedUsers"
                        :items="users"
                        item-text="username"
                        item-value="username"
                        dense
                        solo
                        autofocus
                      >
                        <template v-slot:selection="data">
                          <span v-bind="data.attrs" @click="data.select">{{ data.item.username || 'Отвественный' }}</span>
                        </template>
                        <template v-slot:item="data">
                          <v-list-item-content @click="swapTaskResponsible(lead._id, data.item.username, data.item._id, index)">
                            <v-list-item-title v-if="data.item.username" v-html="data.item.username"></v-list-item-title>
                            <v-list-item-title v-else>Не выбрано</v-list-item-title>
                            <v-list-item-subtitle v-if="data.item.name.length" v-html="` (${data.item.name})(${data.item.roles[0]})`"></v-list-item-subtitle>
                          </v-list-item-content>
                        </template>
                      </v-autocomplete>
                    </v-card>
                  </template>
                </Modal>
                <v-btn icon title="Выполнить задачу c комментарием" @click="dialogSuccessMess = message.id">
                  <v-icon>mdi-comment-text-multiple-outline</v-icon>
                </v-btn>
                <Modal v-if="dialogSuccessMess === message.id" @close="dialogSuccessMess = 0" no-border>
                  <template v-slot:body>
                    <v-card class="pa-4">
                      <v-card-title class="text-center">Примечание</v-card-title>
                      <v-textarea v-model="rightBar.message" :value="rightBar.message" label="Укажите примечание к выполененой задаче"/>
                      <v-card-actions>
                        <v-btn
                          text
                          title="Выполнить задачу c комментарием"
                          @click="executeTask(lead._id,message)"
                          class="ml-auto"
                        >
                          Подтвердить выполение<v-icon>mdi-check</v-icon>
                        </v-btn>
                      </v-card-actions>
                    </v-card>
                  </template>
                </Modal>
                <v-btn v-if="message.statusTask" @click="executeTask(lead._id,message)" icon title="Выполнить задачу"><v-icon>mdi-check</v-icon></v-btn>
              </div>
            </div>
            <div class="bar-container-text" v-if="!message.statusTask && message.task" >
              <div class="d-flex flex-column align-start">
                <span>Задача:<v-chip x-small color="blue" style="color: white">{{message.task}}</v-chip></span>
                <span v-if="message.taskDate">Выполнить до:<v-chip x-small color="blue" style="color: white">{{formatDate(message.taskDate) + ' ' + (message.taskHour && message.taskHour || '09:00')}}</v-chip></span>
                <span v-if="message.taskDate && message.success">Выполнено:<v-chip x-small color="blue" style="color: white">{{message.success}}</v-chip></span>
                <span v-if="message.taskDate && message.success && message.comments">Примечание: <span style="font-size: 12px; color: #000000">{{message.comments}}</span></span>
              </div>
              <v-chip class="ml-auto" small color="green" style="color: white">Выполнено!</v-chip>
            </div>
          </div>
        </div>
        <div :key="222" v-show="!rightBar.calendar" class="bar-mess">
          <div class="mess-wrap">

            <div v-if="selectedFile" class="bar-mess__attach">
              <span>Прикрепленные файлы: {{selectedFile.length}} шт.</span>
            </div>
            <div class="mess-top fullscreen">
              <v-btn
                v-for="tab in rightBar.tabs"
                :key="tab.id"
                :class="{'_active':rightBar.activeTab === tab.title}"
                class="mess-tab"
                text
                @click="rightBar.activeTab = tab.title"
                :icon="tab.icon"
              >
                {{tab.title}}
                <v-icon>mdi-{{tab.mdi}}</v-icon>
              </v-btn>
              <v-menu top offset-y>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn text v-bind="attrs" v-on="on" :loading="!templates.length && templatesLoad" @click="getTemplates" width="100">
                    Шаблоны
                  </v-btn>
                </template>
                <v-list>
                  <v-list-item
                    v-for="(temp, i) in templates"
                    :key="temp._id"
                  >
                    <v-list-item-title style="line-height: inherit!important;">
                      <a target="_blank" :href="`https://wa.me/${lead.phone}?text=${temp.sms}`">
                        <v-chip small :style="{
                          backgroundColor: temp.color,
                          cursor: 'pointer'
                        }"
                        >{{ temp.name }}</v-chip>
                      </a>
                    </v-list-item-title>
                  </v-list-item>
                </v-list>
              </v-menu>
              <div style="color: #3183FF" class="ml-auto mr-6">
                <v-icon color="#3183FF" class="mr-2">mdi-file-document-outline</v-icon>
                <v-dialog
                  v-model="dialog"
                  width="500"
                >
                  <template v-slot:activator="{ on, attrs }">
                  <span
                    v-bind="attrs"
                    v-on="on"
                  >
                    Скачать договор
                  </span>
                  </template>

                  <v-card class="pa-5">
                    <v-card-title class="text-h5">
                      Создать договор
                    </v-card-title>
                    <v-divider class="mb-5"></v-divider>
                    <v-card-text class="user-dialog">
                      <div class="dialog-container" style="width: 100%">
                        <span>Предмет договора</span>
                        <input style="min-width: 100%;" type="text" placeholder="index_task">
                      </div>
                      <div class="d-flex justify-space-between mt-3">
                        <div style="max-width: 120px;width: 120px" class="dialog-container">
                          <span>Стоимость</span>
                          <input type="text" placeholder="Введите число">
                        </div>
                        <div style="max-width: 120px;width: 120px" class="dialog-container">
                          <span>Предоплата</span>
                          <input type="text" placeholder="Введите число">
                        </div>
                        <div style="max-width: 120px;width: 120px" class="dialog-container">
                          <span>Доплата</span>
                          <input type="text" placeholder="Введите число">
                        </div>
                      </div>
                      <div style="max-width: 120px;width: 120px" class="dialog-container mt-3">
                        <span>Дата доплаты</span>
                        <input type="date" placeholder="Укажите дату">
                      </div>
                    </v-card-text>

                    <v-divider></v-divider>

                    <v-card-actions>
                      <v-btn
                        color="primary"
                        elevation="2"
                        raised
                        @click="dialog = false"
                        class="mx-auto"
                      >
                        Создать договор
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
                <v-dialog
                  v-model="dialogLog"
                  width="600"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn @click="getLog"  icon :loading="loadingLogs" v-bind="attrs" v-on="on" class="ml-2">
                      <v-icon>mdi-eye</v-icon>
                    </v-btn>
                  </template>
                  <v-card class="pa-5">
                    <v-card-title class="text-h5">
                      История лида
                      <v-progress-linear
                        :active="loadingLogs"
                        :indeterminate="loadingLogs"
                        absolute
                        bottom
                        color="primary accent-4"
                      ></v-progress-linear>
                    </v-card-title>
                    <v-divider class="mb-5"></v-divider>
                    <v-card-text v-if="!loadingLogs" class="user-dialog">
                      <div v-for="(item, i) in logs" :key="`log-${i}`" >
                        <v-row class="align-center" no-gutters>
                          <v-col cols="4">
                            {{item.log}}
                          </v-col>
                          <v-col cols="2" class="text--secondary">
                            <v-fade-transition leave-absolute>
                                <span key="1">
                                  {{item.user.username}}
                                </span>
                            </v-fade-transition>
                          </v-col>
                          <v-col cols="4">
                            <v-chip small>{{formatDate(item.createdAt, true)}}</v-chip>
                          </v-col>
                          <v-col cols="2">
                            <v-btn
                              text
                              color="red"
                              @click="deleteLog(item.id)"
                              :loading="loadingDeleteLog"
                            >
                              Удалить
                            </v-btn>
                          </v-col>
                        </v-row>
                        <v-divider v-if="logs.length > i + 1"/>
                      </div>
                    </v-card-text>
                  </v-card>
                </v-dialog>
              </div>
            </div>
            <div class="mess-top mobscreen">
              <div class="d-flex align-center justify-space-between px-3" style="width: 100%">
                <span class="color-blue">{{rightBar.activeTab}}</span>
                <v-menu>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      icon
                      class="ml-auto"
                    >
                      <v-icon color="#3183FF">mdi-plus</v-icon>
                    </v-btn>
                  </template>
                  <v-list>
                    <v-list-item
                      class="flex-wrap flex-xs-column"
                    >
                      <v-btn
                        v-for="(tab, index) in rightBar.tabs"
                        :key="tab.id"
                        :class="{'_active':rightBar.activeTab === tab.title}"
                        class="mess-tab justify-start"
                        text
                        @click="rightBar.activeTab = tab.title"
                        :icon="tab.icon"
                        :style="{
                          width: index === 1 && '100%'
                      }"
                      >
                        {{tab.title}}
                        <v-icon>mdi-{{tab.mdi}}</v-icon>
                      </v-btn>
                      <div style="color: #3183FF" class="ml-auto mr-6">
                        <v-icon color="#3183FF" class="mr-2">mdi-file-document-outline</v-icon>
                        <v-dialog
                          v-model="dialog"
                          width="500"
                        >
                          <template v-slot:activator="{ on, attrs }">
                              <span
                                v-bind="attrs"
                                v-on="on"
                              >
                                Скачать договор
                              </span>
                          </template>

                          <v-card class="pa-5">
                            <v-card-title class="text-h5">
                              Создать договор
                            </v-card-title>
                            <v-divider class="mb-5"></v-divider>
                            <v-card-text class="user-dialog">
                              <div class="dialog-container" style="width: 100%">
                                <span>Предмет договора</span>
                                <input style="min-width: 100%;" type="text" placeholder="Введите текст">
                              </div>
                              <div class="d-flex justify-space-between mt-3">
                                <div style="max-width: 120px;width: 120px" class="dialog-container">
                                  <span>Стоимость</span>
                                  <input type="text" placeholder="Введите число">
                                </div>
                                <div style="max-width: 120px;width: 120px" class="dialog-container">
                                  <span>Предоплата</span>
                                  <input type="text" placeholder="Введите число">
                                </div>
                                <div style="max-width: 120px;width: 120px" class="dialog-container">
                                  <span>Доплата</span>
                                  <input type="text" placeholder="Введите число">
                                </div>
                              </div>
                              <div style="max-width: 120px;width: 120px" class="dialog-container mt-3">
                                <span>Дата доплаты</span>
                                <input type="date" placeholder="Укажите дату">
                              </div>
                            </v-card-text>

                            <v-divider></v-divider>

                            <v-card-actions>
                              <v-btn
                                color="primary"
                                elevation="2"
                                raised
                                @click="dialog = false"
                                class="mx-auto"
                              >
                                Создать договор
                              </v-btn>
                            </v-card-actions>
                          </v-card>
                        </v-dialog>
                        <v-icon class="ml-2">mdi-eye</v-icon>
                      </div>
                    </v-list-item>
                  </v-list>
                </v-menu>
              </div>
            </div>
            <div class="mess-bot" :class="{'_task':rightBar.activeTab === 2}">
<!--              <v-text-field-->
<!--                v-show="rightBar.activeTab === rightBar.tabs[0].title"-->
<!--                filled-->
<!--                label="Введите текст"-->
<!--                value=""-->
<!--                height="155px"-->
<!--                v-model="message"-->
<!--                prepend-inner-icon=""-->
<!--              ></v-text-field>-->
              <v-textarea
                v-show="rightBar.activeTab === rightBar.tabs[0].title"
                filled
                label="Введите текст"
                value=""
                height="155px"
                v-model="message"
                prepend-inner-icon=""
                class="input-send-message mr-12 pr-12"
                />
              <v-btn
                icon
                :loading="loadingSendMessage"
                @click="handleFileImport"
                class="send-message"
                style="right: 50px"
                id="send-message-1"
              >
                <v-icon>mdi-paperclip</v-icon>
              </v-btn>

              <input @change="onFileChanged" ref="uploader" id="upload" type="file" hidden>

              <v-btn
                v-show="rightBar.activeTab === rightBar.tabs[0].title"
                class="send-message"
                icon
                :loading="loadingSendMessage"
                :disabled="loadingSendMessage"
                @click="sendMessage(lead._id)"
              >
                <v-icon>mdi-send</v-icon>
              </v-btn>
              <div v-if="rightBar.activeTab === rightBar.tabs[1].title" class="task-bot-container">
                <div class="select-container">
                  <v-row class="select-container-v-row">
                    <v-select
                      :items="rightBar.task"
                      v-model="rightBar.selectedTask"
                      item-text="name"
                      item-value="name"
                      label="Выбрать задачу"
                      solo
                    >
                    </v-select>
                    <v-autocomplete
                      v-model="selectedUsers"
                      :items="users"
                      item-text="username"
                      item-value="username"
                      dense
                      solo
                      autofocus
                    >
                      <template v-slot:selection="data">
                        <span v-bind="data.attrs" @click="data.select">{{ data.item.username || 'Отвественный' }}</span>
                      </template>
                      <template v-slot:item="data">
                        <v-list-item-content @click="selectTaskUser(data.item._id, data.item.username)">
                          <v-list-item-title v-if="data.item.username" v-html="data.item.username"></v-list-item-title>
                          <v-list-item-title v-else>Не выбрано</v-list-item-title>
                          <v-list-item-subtitle v-if="data.item.name.length" v-html="` (${data.item.name})(${data.item.roles[0]})`"></v-list-item-subtitle>
                        </v-list-item-content>
                      </template>
                    </v-autocomplete>
                    <div style="transform: translate(0, -30px)">
                      <v-menu
                        ref="menu1"
                        v-model="menu1"
                        :close-on-content-click="false"
                        transition="scale-transition"
                        offset-y
                        max-width="290px"
                        min-width="auto"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-text-field
                            v-model="rightBar.taskDate"
                            prepend-icon="mdi-calendar"
                            label="Дата"
                            v-bind="attrs"
                            hint="MM/DD/YYYY format"
                            v-on="on"
                          ></v-text-field>
                        </template>
                        <v-date-picker
                          v-model="rightBar.taskDate"
                          locale="ru"
                          :first-day-of-week="1"
                          no-title
                          format="MM.DD.YYYY"
                          @input="menu1 = false"
                        ></v-date-picker>
                      </v-menu>
                    </div>
                   <div style="transform: translate(0, -30px)"><span class="mr-2">Время:</span>
                     <input v-model="rightBar.hour" type="time" id="appt" name="appt"
                            min="00:00" max="24:00" width="50px" class="mb-4">
                   </div>
<!--                    <v-menu-->
<!--                      ref="menu"-->
<!--                      v-model="menu2 && 1===2"-->
<!--                      :close-on-content-click="false"-->
<!--                      :nudge-right="40"-->
<!--                      :return-value.sync="rightBar.hour"-->
<!--                      transition="scale-transition"-->
<!--                      offset-y-->
<!--                      max-width="290px"-->
<!--                      min-width="290px"-->
<!--                    >-->
<!--                      <template v-slot:activator="{ on, attrs }">-->
<!--                        <v-text-field-->
<!--                          v-model="rightBar.hour"-->
<!--                          label="Время"-->
<!--                          prepend-icon="mdi-clock-time-four-outline"-->
<!--                          readonly-->
<!--                          v-bind="attrs"-->
<!--                          v-on="on"-->
<!--                        ></v-text-field>-->
<!--                      </template>-->
<!--                      <v-time-picker-->
<!--                        v-if="menu2 && 1===2"-->
<!--                        v-model="rightBar.hour"-->
<!--                        full-width-->
<!--                        @click:minute="$refs.menu.save(rightBar.hour)"-->
<!--                      ></v-time-picker>-->
<!--                    </v-menu>-->
                    <div style="transform: translate(0, -30px)">
                      <v-menu
                        v-if="1===2"
                        top
                        offset-y
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn text v-bind="attrs" v-on="on" :loading="!users.length && getUsersLoading" @click="getUsers" class="mt-4">
                            {{ selectedTaskUser && selectedTaskUser.username || 'Отвественный' }}
                          </v-btn>
                        </template>

                        <v-list v-if="1===2">
                          <v-list-item
                            v-for="(user, i) in users"
                            :key="user._id"
                          >
                            <v-list-item-title @click="selectTaskUser(user._id, user.username)" style="line-height: inherit!important;">
                              <v-chip small style="cursor: pointer">{{ user.username }}</v-chip>
                            </v-list-item-title>
                          </v-list-item>
                        </v-list>
                      </v-menu>
                    </div>
                    <v-btn
                      class="send-message"
                      icon
                      :loading="loadingSendMessage"
                      :disabled="loadingSendMessage"
                      @click="sendMessage(lead._id)"
                    >
                      <v-icon>mdi-send</v-icon>
                    </v-btn>
                  </v-row>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div :key="333" class="right-bar" v-show="rightBar.calendar">
          <Calendar
            v-if="rightBar.calendar"
            @removeCalendar="removeCalendar"
            :lead="lead"
          />
        </div>
      </transition-group>
    </div>
  </div>
  <div v-else class="skeleton">
    <v-skeleton-loader
      type="list-item-three-line, list-item-three-line, list-item-three-line"
    ></v-skeleton-loader>
    <v-divider vertical class="ml-4"/>
    <v-skeleton-loader
      type="list-item-two-line, card"
    ></v-skeleton-loader>
  </div>
</template>

<script>
import Calendar from './Calendar'
import api from '@/API/api'
import url from '@/API/url'
import apiAddress from '@/API/address'
import formatDate from "./utils/formatDate";
import {mapGetters} from 'vuex'
import store from '@/vuex/store'
import logger from '@/components/utils/logger'
import Modal from '@/components/Modal'

export default {
  name: 'Lead',
  components: {
    Modal,
    Calendar
  },
  data () {
    return {
      validPhone: true,
      selectElem: '',
      selectedUsers: [],
      lead: {},
      // не пустой для того, чтобы окно меню вылазило наверх от кнопки
      users: [
        {},
        {},
        {},
        {}
      ],
      dropped: 0,
      dropFlag: false,
      selectedTaskUser: {},
      getUsersLoading: false,
      loading: true,
      dialog: false,
      dialogLog: false,
      logs: [],
      loadingLogs: false,
      loadingDeleteLog: false,
      notifications: false,
      menu1: false,
      menu2: false,
      leftBar: {
        tabs: [
          { title: 'Данные', id: 1 },
          { title: 'Документы', id: 2 },
          { title: 'Финансы', id: 3 },
        ],
        activeTab: 1,
        show: false,
        isInputBudget: false,
        isInputDebt: false,
        isInputPrepay: false,
        isInputTrueAnswer: false,
        isProposedAmount: false,
        answer: '',
        budget: '',
        debt: '',
        proposed_amount: '',
        isInputLeadInfo: {
          leadName: '',
          leadPhone: '',
          leadEmail: '',
          leadCity: '',
        }
      },
      rightBar: {
        tabs: [
          { title: 'Примечание', id: 1 },
          { title: 'Задача', id: 2 },
          // { mdi: 'message-text-outline', id: 3 },
          // { mdi: 'email-outline', id: 4 },
          // { mdi: 'whatsapp', id: 5 }
        ],
        activeTab: 'Примечание',
        calendar: false,
        task: [],
        selectedTask: "",
        statusTask: false,
        taskDate: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10),
        hour: "",
        message: ''
      },
      dialogSuccessMess: 0,
      dialogSwapTaskResponsible: 0,
      message: '',
      loadingSendMessage: false,
      tags: [],
      isSelecting: false,
      selectedFile: null,
      regions: [],
      // не пустой для того, чтобы окно меню вылазило наверх от кнопки
      templates: [
        {},
        {},
        {},
        {}
      ],
      templatesLoad: false,
      loadingCities: false,
      cities: [],
      citiesItems: [],
      search: null,
    }
  },
  computed: {
    url,
    ...mapGetters(["USER"]),
    isDev: function () {
      // чтобы не удаляли тестовые лиды для разработки
      return window.location.hostname === 'localhost'
    },
    statusLead() {
      return this.lead.status && this.lead.status.name || 'Указать статус'
    },
    phoneNumberRule() {
      return (value) => {
        const regex = /^[0-9]{11}$/ // regex to match 11-digit phone numbers
        if (!regex.test(value)) {
          return 'Некорректный номер'
        }
        return true
      }
    },
  },
  async created () {
    await this.initialize()
    await this.logLead('Просмотр лида') // пользователь открыл лид
    this.isDev && await api.settingsLead({_id: this.lead._id})
  },
  watch: {
    search (val) {
      val && val !== this.lead.city && !this.cities.length && this.getCities(val)
    },
  },

  methods: {
    formatDate,
    dragEnter () {
      this.dropFlag = true
    },
    dragOver () {
      this.dropped = 2
    },
    dragLeave () {
      this.dropFlag = false
    },
    drop (e) {
      const files = Array.from(e.dataTransfer.files)
      this.selectedFile = files[0]
      this.dropFlag = false
    },
    async getCities (val) {
      this.loadingCities = true
      if (!this.cities.length) {
        await api.getCities().then(res => {
          this.cities = res.data.cities
        })
      }
      this.citiesItems = this.cities.filter(e => {
        return e.city
      })
      this.loadingCities = false

    },
    async initialize() {
      await api.getLead({ _id: this.$route.params.id, user_id: this.USER._id }).then(res => {
        if (res.data.status) this.lead = res.data.lead
        else alert('Что-то пошле не так ....\n' + 'message: ' + res.data.message)
      }).catch(res => {
        if (!res.response.data.status) this.$router.push({name: 'Auth'})
      })
      await api.getStatusLead().then(res => (this.tags = res.data.statusLeads) || alert('Что-то пошле не так.. Ошибка загрузки статусов\n' + 'message: ' + res.data.message))
      //когда лид открывается, нужно поставить ему статус "В работе"
      //находим статус и ставим если пользователь не админ
      const tagsIndex = this.tags.findIndex(element => element.name === 'В работе');
      // if (this.USER.roles.indexOf('ADMIN') < 0 && !this.lead.status && this.tags.length) {
      //   await api.selectStatusLead({leadId: this.lead._id, statusId: this.tags[tagsIndex]._id}).then(res => {
      //     this.lead.status = res.data.status
      //   })
      // }
      await api.getTasks().then(res => res.data.status && (this.rightBar.task = res.data.tasks) || alert('Что-то пошле не так.. Ошибка загрузки задач\n' + 'message: ' + res.data.message))

      //доп поля берутся из настроек. если доп поле есть в настройках, а в лиде нет, то оно добавляется
      await api.getFields().then(res => {
        let flag = false
        if (res.data.status) {
          if (this.lead.fields.length) {
            res.data.fields.forEach(obj2 => {
              if (!this.lead.fields.some(obj1 => obj1._id === obj2._id)) {
                this.lead.fields.push(obj2);
                flag = true
              }
            });
            if (flag) this.changeLeadFields(this.lead.fields)
          }
          else {
            this.lead.fields = res.data.fields
            this.changeLeadFields(this.lead.fields)
          }
        }  else return alert('Ошибка загрузки доп.полей')
      })
      await api.getRegions().then(res => {
        if (res.data.status) {
          this.regions = res.data.region
          this.lead.region = this.regions.find(el => el._id === this.lead.region);
        } else return alert('Ошибка загрузки регионов')
      })
      await this.getUsers()
      this.loading = false
    },
    changeValueLeadFields (index) {
      this.changeLeadFields(this.lead.fields)
    },
    changeValueLead () {
      this.validPhone && console.log(123)
      setTimeout(() => {
        this.changeLead({
          _id: this.lead._id,
          name: this.lead.name,
          email: this.lead.email,
          phone: this.lead.phone,
          city: this.lead.city
        })
      }, 100)
    },
    async changeLeadFields (fields) {
      await api.changeLeadFields({
        _id: this.lead._id,
        fields,
        budget: this.lead.budget,
        debt: this.lead.debt,
        prepay: this.lead.prepay,
        answer: this.lead.answer,
        proposed_amount: this.lead.proposed_amount
      })
      await this.logLead('Доп. поля') // пользователь изменил доп поля
    },
    async changeLead (data) {
      await api.changeLead(data)
      await this.logLead('Основные поля') // пользователь изменил основные поля
    },
    async selectStatus(lead, status, index) {
      if (status.name === 'Отказ') {
        const comment = prompt('Пожалуйста, укажите комментарий отказа');
        await api.selectStatusLead({leadId: lead._id, statusId: status._id, comment}).then(res => {
          if (res.data.status) {
            this.$set(this.lead, 'status', this.tags[index])
            this.$set(this.lead, 'status_comment', comment)
          }
        })
      } else {
        await api.selectStatusLead({leadId: lead._id, statusId: status._id}).then(res => {
          if (res.data.status) {
            this.$set(this.lead, 'status', this.tags[index])
          }
        })
      }
      await this.logLead('Новый статус') // пользователь установил новый статус лида
    },
    async toRegion(leadId, regionId, index) {
      await api.changeRegion({leadId, regionId}).then(res => {
        if (res.data.status) {
          this.lead.region = this.regions[index]
          this.$forceUpdate()
        }
      })
      await this.logLead('Изменение региона') // пользователь установил новый регион лида
    },
    handleFileImport() {
      this.isSelecting = true;

      // After obtaining the focus when closing the FilePicker, return the button state to normal
      window.addEventListener('focus', () => {
        this.isSelecting = false
      }, { once: true });

      // Trigger click on the FileInput
      this.$refs.uploader.click();
    },
    async onFileChanged(e) {
      this.selectedFile = e.target.files[0];
    },
    async sendFile (_id) {
      const formData = new FormData()
      formData.append('_id', _id)
      formData.append('message', this.message)
      formData.append('type', 'Файл')
      formData.append('fromId', this.USER._id)
      formData.append('fromUsername', this.USER.username)
      formData.append('task', this.rightBar.selectedTask)
      formData.append('taskDate', new Date(this.rightBar.taskDate))
      formData.append('taskHour', this.rightBar.hour)
      formData.append('statusTask', this.rightBar.selectedTask && true || false)
      formData.append('success', '')
      formData.append('date', new Date())
      formData.append('file', this.selectedFile)
      // await api.sendFile(formData)
      await apiAddress().post('/send-file-lead', formData, {
        headers: {
          // eslint-disable-next-line
          'Authorization': `Bearer ${store.state.token}`,
          'Content-Type': 'multipart/form-data'
        }
      })
      this.selectedFile = null
    },
    async sendMessage(_id) {
      let timeStr
      if (this.rightBar.selectedTask) {
        if (!this.rightBar.hour) {
          alert('Не указано время')
          throw 'Не указано время'
        }
      }
      if (this.rightBar.hour) timeStr = this.rightBar.hour;
      else {
        const now = new Date();
        const hours = now.getHours().toString().padStart(2, '0');
        const minutes = now.getMinutes().toString().padStart(2, '0');
        timeStr = `${hours}:${minutes}`
      }
// create a new Date object with the current date and time
      const date = new Date(this.rightBar.taskDate);
// extract the hours and minutes from the time string
      const [hours, minutes] = timeStr.split(':').map(Number);
// set the hours and minutes on the date object
      date.setHours(hours);
      date.setMinutes(minutes);
      const result = date.toISOString()
      const random = Math.random().toString().replace('.', '')

      this.loadingSendMessage = true
      const message = {
        name: "Тест",
        type: this.rightBar.selectedTask && 'Задача' || 'Примечание',
        message: this.message,
        from: {
          _id: this.selectedTaskUser && this.selectedTaskUser._id || this.USER._id,
          username: this.selectedTaskUser && this.selectedTaskUser.username || this.USER.username
        },
        id: random,
        task: this.rightBar.selectedTask,
        taskDate: result,
        taskHour: this.rightBar.hour,
        statusTask: this.rightBar.selectedTask && true || false,
        success: '',
        date: new Date()
      }
      const task = {
        id: random,
        task: message.task,
        taskDate: message.taskDate,
        taskHour: message.taskHour,
        statusTask: message.statusTask,
        success: message.success,
      }
      if (!this.selectedFile) {
        if (message.type === 'Задача') {
          this.lead.task.push(task)
          await api.changeLeadTask({_id: this.$route.params.id, task: task})
        }
        await api.sendMessage({_id: _id, message})
          .then(res => {
            if (res.data.status) {
              this.loadingSendMessage = false
              this.lead.messages.push(message)
              this.rightBar.selectedTask = ""
              this.rightBar.taskDate = (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10)
              this.rightBar.hour = ""
              this.message = ""
            }
          })
      }
      else {
        if (message.task.length) {
          this.lead.task.push(task)
          await api.changeLeadTask({_id: this.$route.params.id, task: task})
        }
        await this.sendFile(_id)
        message.file = this.selectedFile
        message.type = 'Файл'
        this.loadingSendMessage = false
        this.lead.messages.push(message)
        this.rightBar.selectedTask = ""
        this.rightBar.taskDate = (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10)
        this.rightBar.hour = ""
        this.message = ""
        await api.getLead({ _id: this.$route.params.id, user_id: this.USER._id }).then(res => res.data.status && (this.lead = res.data.lead) ||  alert('Ошибка загрузки лида'))
      }
    },
    async executeTask(_id, message) {
      const date = this.formatDate(new Date(), true)
      const comments = this.rightBar.message || ''
      await api.executeTaskLead({_id, id: message.id, date: date, comments})
        .then(res => {
          if (res.data.status) {
            this.lead.messages.filter(obj => {
              if (obj.id === message.id) {
                obj.statusTask = false
                obj.success = date
                obj.comments = comments
                this.$forceUpdate()
                this.dialogSuccessMess = 0
              }
            });
          }
        })
      await this.logLead('Выполнение задачи') // пользователь подтвердил выполнение задачи лида
    },
    async getTemplates () {
      this.templatesLoad = true
      await api.getTemplateSMS().then(res => {
        res.data.status && (this.templates = res.data.template)
        this.templatesLoad = false
      })
    },
    async getUsers () {
      this.getUsersLoading = true
      await api.getUsers().then(res => {
        res.data.status && (this.users = res.data.users)
      })
      await api.getAdmins().then(res => this.users = res.data.users.concat(this.users))
      this.getUsersLoading = false
    },
    selectTaskUser (_id, username) {
      this.selectedTaskUser = {_id, username}
    },
    async swapTaskResponsible (_id, username, user_id, messageIndex) {
      this.lead.messages[messageIndex].from.username = username
      this.lead.messages[messageIndex].from._id = user_id
      await api.swapTaskResponsible({_id, username, user_id, messageIndex})
        .then(() => this.dialogSwapTaskResponsible = false)
    },
    removeCalendar () {
      this.rightBar.calendar = false
    },
    async logLead (log) {
      await logger(this.lead._id, log)
    },
    async getLog () {
      if (!this.logs.length) {
        this.loadingLogs = true
        await logger(this.lead._id, '').then(r => {
          this.logs = r.data.log.reverse()
          this.loadingLogs = false
        })
      } else return false
    },
    async deleteLog () {
      if (!this.logs.length) {
        await logger(this.lead._id, '').then(r => {
          this.logs = r.data.log.reverse()
        })
      } else return false
    },
    async deleteLead () {
      await api.deleteLead({_id: this.lead._id}).then(() => this.$router.replace('/deal'))
    },
    debounce(func, wait, immediate) {
      let timeout;

      return function executedFunction() {
        const context = this;
        const args = arguments;

        const later = function() {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };

        const callNow = immediate && !timeout;

        clearTimeout(timeout);

        timeout = setTimeout(later, wait);

        if (callNow) func.apply(context, args);
      };
    },
  },
}
</script>

<style scoped lang="scss">
.skeleton {
  display: grid;
  grid-template-columns: 4fr 1fr 8fr;
  margin-top: 20px;
}
  .user {
    height: 100vh;
    max-height: 100vh;
    min-height: 100vh;
    overflow: hidden;
    display: flex;
    @media (max-width: 1005px) {
      flex-direction: column;
    }

    .drop-window-wrap {
      position: relative;
      border: 1px solid gray;
      padding: 20px;
      width: 100%;
      height: 100%;
      background-color: rgba(28, 19, 19, 0.3);
      backdrop-filter: blur(6px);
      z-index: 5;
      .drop-window {
        pointer-events: none;
        position: absolute;
        width: 50%;
        height: 20%;
        background-color: #FFFFFF;
        border-radius: 20px;
        z-index: 6;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -70%);
        display: flex;
        align-items: center;
        justify-content: center;
        p {
          text-align: center;
          font-size: 24px;
          opacity: .8;
        }
      }
    }
    .username-block {
      display: none;
      justify-content: space-between;
      align-items: center;
      padding: 10px 16px;
      background: linear-gradient(0deg, rgba(49, 131, 255, 0.12), rgba(49, 131, 255, 0.12)), #FFFFFF;
      @media (max-width: 1005px) {
        display: flex;
      }
    }
    .left-bar {
      min-width: 340px;
      max-width: 340px;
      background-color: #E6F0FF;
      height: 100%;
      padding: 20px 16px 0 16px;
      position: relative;
      .budget {
        display: grid;
        grid-template-rows: 2fr;
        grid-template-columns: 2fr 2fr;
        input {
          height: 20px; width: 60px; padding: 8px
        }
      }
      @media (max-width: 1005px) {
        display: none;
        &._active {
          display: block;
          position: fixed;
          top: 105px;
          width: 100vw;
          max-width: inherit;
          z-index: 100;
        }
      }
      .user-name {
        font-weight: bold;
        font-size: 17px;
        line-height: 23px;
        color: rgba(0, 0, 0, 0.75);
      }
      .user-added {
        color: rgba(0, 0, 0, 0.3);
        span {
          color: rgba(0, 0, 0, 0.75);
        }
      }
      .chip {
        display: flex;
        align-items: flex-start;
        .chip-title {
          padding-top: 13px;
          margin-right: 10px;
        }
      }
      .status,.budget {
        span {
          margin: 0 3px;
        }
      }
      .user-calendar {
        background: linear-gradient(0deg, rgba(49, 131, 255, 0.12), rgba(49, 131, 255, 0.12)), #FFFFFF;
        box-shadow: inset 0px 1px 0px rgba(49, 131, 255, 0.32), inset 0px -1px 0px rgba(49, 131, 255, 0.32);
        padding: 7px 0;
        display: flex;
        align-items: center;
        margin: 15px 0;
        img { margin-right: 10px }
      }
      .user-tabs {
        border: 1px solid #3183FF;
        box-sizing: border-box;
        border-radius: 4px;
        padding: 6px 4px;
        display: flex;
        justify-content: space-around;
        .user-tab {
          position: relative;
          color: #8BAFE4;
          font-size: 10px;
          &._active {
            color: #FFFFFF;
            background-color: #3183FF;
          }
        }
      }
      .tab-data {
        margin: 15px 0;
        border-bottom: 1px solid rgba(0, 0, 0, 0.2);
        padding-bottom: 15px;
        input {
          background-color: white;
          padding-left: 5px;
          height: 20px;
          color: black;
        }
        select {
          height: 30px;
          font-size: 12px;
          padding: 2px;
          padding-left: 5px;
        }
        .data-element {
          display: flex;
          align-items: center;
          justify-content: space-between;
          margin: 4px 0;
          cursor: pointer;
          p {
            margin: 0;
          }
          img {width: 34px}
        }
      }
      overflow-y: auto;
      padding-bottom: 40px;
    }
    .right-bar {
      width: 100%;
      max-height: calc(100vh - 180px);
      overflow-y: auto;
      padding: 10px;
      padding-bottom: 100px;
      @media (max-width: 1005px) {
        max-height: calc(100vh - 220px);
        min-height: calc(100vh - 220px);
      }
      @media (max-width: 1005px) {
      }
      position: relative;
      .bar-container {
        border: 1px solid rgba(0, 0, 0, 0.16);
        &.warn { border: 1px solid red; }
        box-sizing: border-box;
        border-radius: 8px;
        padding: 12px;
        margin-bottom: 10px;
        font-size: 13px;
        &.task {
          background-color: rgba(147, 255, 165, 0.73)
        }
        .bar-container-title {
          display: flex;
          justify-content: space-between;
          color: #324661;
          p {
            display: flex;
            align-items: center;
            font-weight: 600;
            font-size: 13px;
            img {
              margin: 0 10px;
            }
            &:last-child {
              color: rgba(0,0,0,.3);
              font-weight: 400;
            }
          }
        }
        .bar-container-text,.bar-container-warn {
          display: flex;
          align-items: center;
          img {
            margin: 0 10px;
          }
          span {
            margin: 0 10px;
            color: rgba(0,0,0,.3);
          }
        }
        .bar-container-warn {
          margin-top: 8px;
          display: flex;
          justify-content: space-between;
          span {
            color: red;
            font-weight: 600;
            margin: 0 5px;
          }

          .status-true {
            color: #3183FF;
            cursor: pointer;
          }
          .status-false {
            color: red;
            cursor: pointer;
          }
        }
      }
    }
    .bar-mess {
      width: 100%;
      background: #FFFFFF;
      box-sizing: border-box;
      padding: 20px 0 20px 0;
      overflow: hidden;
      min-height: 180px;
      float: bottom;
      .mess-wrap {
        border: 1px solid rgba(0, 0, 0, 0.10);
        position: absolute;
        bottom: 40px;
        width: 100%;
        background-color: white;
      }
      .bar-mess__attach {
        width: 100%; height: 20px; background-color: #3183FF;
        span {
          color: white;
          font-size: 12px;
          opacity: 0.7;
          padding-left: 10px;
        }
      }
      .mess-top {
        display: flex;
        align-items: center;
        z-index: 1000;
        background-color: #FFFFFF;
        -webkit-box-shadow: 5px -22px 14px -20px rgba(34, 60, 80, 0.2);
        -moz-box-shadow: 5px -22px 14px -20px rgba(34, 60, 80, 0.2);
        box-shadow: 5px -22px 14px -20px rgba(34, 60, 80, 0.2);
        &.fullscreen {
          @media (max-width: 650px) {
            display: none;
          }
        }
        &.mobscreen {
          display: none;
          @media (max-width: 650px) {
            display: flex;
          }
        }
        .mess-tab {
          position: relative;
          color: #8BAFE4;
          &._active {
            color: #3183FF;
            &:after {
              content: '';
              position: absolute;
              bottom: 0;
              width: 100%;
              height: 2px;
              background-color: #1976D2;
            }
          }
        }
      }
      .mess-bot {
        position: relative;
        .send-message {
          position: absolute;
          top: 10px;
          right: 12px;
          z-index: 10;
          @media (max-width: 600px) {
            top: -35px;
            right: 45px;
          }
        }
        #send-message-1 {
          @media (max-width: 600px) {
            right: 80px!important;
          }
        }
        .task-bot-container {
          margin: 10px 12px;
          .select-container {
            height: 155px;
            .select-container-v-row {
              max-width: calc(100% - 80px);
              @media (max-width: 700px) {
                width: 100%;
                max-width: 100%;
              }
            }
            .row {
              display: grid;
              grid-template-rows: 1fr 1fr;
              grid-template-columns: 1fr 1fr;
              align-items: center;

              grid-gap: 10px;
            }
            @media (max-width: 700px) {
              .row {
              }
            }
          }
        }
      }
    }
  }
  select, input[type=text], textarea {
    background: #FFFFFF;
    border: 1px solid #CCD4DD;
    box-sizing: border-box;
    border-radius: 4px;
    padding: 8px;
    padding-right: 5px;
    max-width: 200px;
    color: rgba(0, 0, 0, 0.9);
  }
  .user-dialog {
    .dialog-container {
      display: flex;
      flex-direction: column;
    }
    span {
      margin-bottom: 5px;
    }
    input {
      background: #FFFFFF;
      border: 1px solid #CCD4DD;
      box-sizing: border-box;
      border-radius: 4px;
      padding: 13px 5px 13px 12px;
      max-width: 100%;
      height: 32px;
    }
  }
  .anim-right-bar-enter-active {
    transition: all .3s;
    transform: scale(0.6);
    opacity: 0.7;
  }
  .anim-right-bar-enter-to {
    transform: scale(1);
  }
  .anim-right-bar-leave-active {
    transition: all .3s;
  }
  .anim-right-bar-leave-to {
    transform: scale(0.6);
    opacity: 0.1;
  }
  .input-send-message {
    @media (max-width: 600px) {
      margin-right: 0!important;
      padding-right: 0!important;
    }
  }
</style>
